CREATE TABLE [dbo].[Lookups] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[Teg] [varchar] (40) NOT NULL ,
	[Ival] [int] NOT NULL ,
	[Item] [varchar] (80) NOT NULL ,
	[Comment] [varchar] (80) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepForm] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[Numm] [int] NOT NULL ,
	[Name] [varchar] (250) NOT NULL ,
	[IdDestination] [int] NOT NULL ,
	[IdTypExec] [int] NOT NULL ,
	[Description] [varchar] (250) NULL ,
	[Report] [image] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepGroup] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[GrpName] [varchar] (250) NOT NULL ,
	[IdParent] [int] NULL ,
	[Numm] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepHistoryLog] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[IdAction] [int] NOT NULL ,
	[ValueId] [int] NOT NULL ,
	[login] [varchar] (30) NOT NULL ,
	[username] [varchar] (30) NOT NULL ,
	[data] [datetime] NOT NULL ,
	[Name] [varchar] (255) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepImports] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[Name] [varchar] (250) NOT NULL ,
	[Description] [varchar] (250) NULL ,
	[Numm] [int] NOT NULL ,
	[FileTemplate] [varchar] (250) NULL ,
	[IdScrEng] [int] NOT NULL ,
	[SQLtext] [text] NULL ,
	[ScriptText] [text] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepLogins] (
	[LoginName] [varchar] (30) NOT NULL ,
	[FullName] [varchar] (40) NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepQuery] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[Numm] [int] NOT NULL ,
	[Name] [varchar] (250) NOT NULL ,
	[Description] [varchar] (250) NULL ,
	[SQLtext] [text] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepRemoteData] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[Numm] [int] NOT NULL ,
	[Name] [varchar] (250) NOT NULL ,
	[Description] [varchar] (250) NULL ,
	[IdRemtServerType] [int] NOT NULL ,
	[ServerName] [varchar] (250) NULL ,
	[ServerGUID] [varchar] (250) NULL ,
	[ComputerName] [varchar] (250) NULL ,
	[IdRemtProtocol] [int] NULL ,
	[Port] [int] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepScript] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[Numm] [int] NOT NULL ,
	[Name] [varchar] (250) NOT NULL ,
	[Description] [varchar] (250) NULL ,
	[IdScrEng] [int] NOT NULL ,
	[ScriptText] [text] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepUsers] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[IdTypObj] [int] NOT NULL ,
	[IdObj] [int] NOT NULL ,
	[LoginName] [char] (40) NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepFrm2Qry] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[IdForm] [int] NOT NULL ,
	[Numm] [int] NOT NULL ,
	[IdQuery] [int] NULL ,
	[IdRemoteData] [int] NULL ,
	[IsMaster] [int] NOT NULL ,
	[QueryShortName] [char] (20) NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepGrpBody] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[IdGroup] [int] NOT NULL ,
	[IdForm] [int] NULL ,
	[IdScript] [int] NULL ,
	[Numm] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[URepParam] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[IdQuery] [int] NULL ,
	[IdRemoteData] [int] NULL ,
	[Numm] [int] NOT NULL ,
	[ParName] [char] (40) NOT NULL ,
	[IdParTyp] [int] NOT NULL ,
	[ParLabel] [char] (40) NOT NULL ,
	[SQL] [text] NULL ,
	[Width] [int] NULL ,
	[LookupField] [varchar] (40) NULL ,
	[LookupDisplay] [varchar] (40) NULL ,
	[LookupDisplayIndex] [int] NULL ,
	[IdTypDefVal] [int] NOT NULL ,
	[DefSQL] [text] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

ALTER TABLE [dbo].[Lookups] WITH NOCHECK ADD 
	CONSTRAINT [PK_Lookups] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepForm] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepForm] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepGroup] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepGroup] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	) WITH  FILLFACTOR = 90  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepHistoryLog] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepHistoryLog] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepImports] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepImports] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepLogins] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepLogins] PRIMARY KEY  CLUSTERED 
	(
		[LoginName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepQuery] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepQuery] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepRemoteData] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepRemoteData] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepScript] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepScript] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepUsers] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepUsers] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepFrm2Qry] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepFrm2Qry] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepGrpBody] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepGrpBody] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepParam] WITH NOCHECK ADD 
	CONSTRAINT [PK_URepParam] PRIMARY KEY  CLUSTERED 
	(
		[Id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[Lookups] WITH NOCHECK ADD 
	CONSTRAINT [IX1_Lookups] UNIQUE  NONCLUSTERED 
	(
		[Teg],
		[Ival]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepGroup] WITH NOCHECK ADD 
	CONSTRAINT [Uq_URepGroup] UNIQUE  NONCLUSTERED 
	(
		[GrpName]
	) WITH  FILLFACTOR = 90  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepHistoryLog] WITH NOCHECK ADD 
	CONSTRAINT [uqURepHistoryLog] UNIQUE  NONCLUSTERED 
	(
		[data],
		[IdAction],
		[ValueId]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepImports] WITH NOCHECK ADD 
	CONSTRAINT [AK_URepImports_Name] UNIQUE  NONCLUSTERED 
	(
		[Name]
	)  ON [PRIMARY] ,
	CONSTRAINT [AK_URepImports_Numm] UNIQUE  NONCLUSTERED 
	(
		[Numm]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepQuery] WITH NOCHECK ADD 
	CONSTRAINT [Uq_URepQuery_Name] UNIQUE  NONCLUSTERED 
	(
		[Name]
	)  ON [PRIMARY] ,
	CONSTRAINT [Uq_URepQuery_Numm] UNIQUE  NONCLUSTERED 
	(
		[Numm]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepRemoteData] WITH NOCHECK ADD 
	CONSTRAINT [AK1_URepRemoteData] UNIQUE  NONCLUSTERED 
	(
		[Name]
	)  ON [PRIMARY] ,
	CONSTRAINT [AK2_URepRemoteData] UNIQUE  NONCLUSTERED 
	(
		[Numm]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepScript] WITH NOCHECK ADD 
	CONSTRAINT [uq_URepScript_Name] UNIQUE  NONCLUSTERED 
	(
		[Name]
	)  ON [PRIMARY] ,
	CONSTRAINT [uq_URepScript_Numm] UNIQUE  NONCLUSTERED 
	(
		[Numm]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepUsers] WITH NOCHECK ADD 
	CONSTRAINT [Uq1_URepUsers] UNIQUE  NONCLUSTERED 
	(
		[IdTypObj],
		[IdObj],
		[LoginName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[URepFrm2Qry] WITH NOCHECK ADD 
	CONSTRAINT [CK_URepFrm2Qry] CHECK ([IdQuery] is null and ((not([IdRemoteData] is null))) or ((not([IdQuery] is null))) and [IdRemoteData] is null)
GO

ALTER TABLE [dbo].[URepGrpBody] WITH NOCHECK ADD 
	CONSTRAINT [CK_URepGrpBody] CHECK ([IdForm] is null and ((not([IdScript] is null))) or ((not([IdForm] is null))) and [IdScript] is null)
GO

ALTER TABLE [dbo].[URepParam] WITH NOCHECK ADD 
	CONSTRAINT [CK_URepParam] CHECK ([IdQuery] is null and ((not([IdRemoteData] is null))) or ((not([IdQuery] is null))) and [IdRemoteData] is null)
GO

 CREATE  INDEX [IX_Lookups] ON [dbo].[Lookups]([Ival], [Teg]) ON [PRIMARY]
GO

 CREATE  INDEX [Uq_URepForm_Name] ON [dbo].[URepForm]([Name]) ON [PRIMARY]
GO

 CREATE  INDEX [Uq_URepForm_Numm] ON [dbo].[URepForm]([Numm]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_URepHistoryLog] ON [dbo].[URepHistoryLog]([login]) ON [PRIMARY]
GO

 CREATE  INDEX [IX1_URepFrm2Qry] ON [dbo].[URepFrm2Qry]([IdForm], [IdQuery], [Numm]) ON [PRIMARY]
GO

 CREATE  INDEX [IX2_URepFrm2Qry] ON [dbo].[URepFrm2Qry]([IdForm], [IdRemoteData], [Numm]) ON [PRIMARY]
GO

 CREATE  INDEX [IX1_URepGrpBody] ON [dbo].[URepGrpBody]([IdGroup], [IdForm]) ON [PRIMARY]
GO

 CREATE  INDEX [IX2_URepGrpBody] ON [dbo].[URepGrpBody]([IdGroup], [IdScript]) ON [PRIMARY]
GO

 CREATE  INDEX [IX1_URepParam] ON [dbo].[URepParam]([IdQuery], [Numm]) ON [PRIMARY]
GO

 CREATE  INDEX [IX2_URepParam] ON [dbo].[URepParam]([IdRemoteData], [Numm]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[URepFrm2Qry] ADD 
	CONSTRAINT [FK_URepFrm2Qry_URepForm] FOREIGN KEY 
	(
		[IdForm]
	) REFERENCES [dbo].[URepForm] (
		[Id]
	),
	CONSTRAINT [FK_URepFrm2Qry_URepQuery] FOREIGN KEY 
	(
		[IdQuery]
	) REFERENCES [dbo].[URepQuery] (
		[Id]
	),
	CONSTRAINT [FK_URepFrm2Qry_URepRemoteData] FOREIGN KEY 
	(
		[IdRemoteData]
	) REFERENCES [dbo].[URepRemoteData] (
		[Id]
	)
GO

ALTER TABLE [dbo].[URepGrpBody] ADD 
	CONSTRAINT [FK_URepGrpBody_URepForm] FOREIGN KEY 
	(
		[IdForm]
	) REFERENCES [dbo].[URepForm] (
		[Id]
	),
	CONSTRAINT [FK_URepGrpBody_URepGroup] FOREIGN KEY 
	(
		[IdGroup]
	) REFERENCES [dbo].[URepGroup] (
		[Id]
	),
	CONSTRAINT [FK_URepGrpBody_URepScript] FOREIGN KEY 
	(
		[IdScript]
	) REFERENCES [dbo].[URepScript] (
		[Id]
	)
GO

ALTER TABLE [dbo].[URepParam] ADD 
	CONSTRAINT [FK_URepParam_URepQuery] FOREIGN KEY 
	(
		[IdQuery]
	) REFERENCES [dbo].[URepQuery] (
		[Id]
	),
	CONSTRAINT [FK_URepParam_URepRemoteData] FOREIGN KEY 
	(
		[IdRemoteData]
	) REFERENCES [dbo].[URepRemoteData] (
		[Id]
	)
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO



CREATE VIEW dbo.vwURepForm
(Id, Numm, Name, IdDestination, IdTypExec, Description)
AS
SELECT Id, Numm, Name, IdDestination, IdTypExec, Description
FROM URepForm
WHERE Id IN (SELECT IdObj FROM URepUsers
                        WHERE (LoginName = user_name() or IS_MEMBER(LoginName)=1) AND IdTypObj = 2) OR
              NOT EXISTS (SELECT * FROM URepUsers
                                     WHERE IdTypObj = 2 AND IdObj = URepForm.Id) OR
              IS_MEMBER('db_owner')=1 OR IS_MEMBER('URep_Admin')=1







GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO



CREATE VIEW dbo.vwURepGroup
(Id, GrpName, IdParent, Numm)
AS
SELECT Id, GrpName, IdParent, Numm
FROM URepGroup
WHERE Id IN
        (SELECT IdObj FROM URepUsers
         WHERE (LoginName = user_name() or IS_MEMBER(LoginName)=1) AND IdTypObj = 1) OR
        NOT EXISTS  (SELECT * FROM URepUsers
                                WHERE IdTypObj = 1 AND IdObj = URepGroup.Id) OR
        IS_MEMBER('db_owner')=1 OR IS_MEMBER('URep_Admin')=1








GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE VIEW dbo.vwURepImports
(Id, Numm, Name, FileTemplate, Description, IdScrEng)
AS
SELECT Id, Numm, Name, FileTemplate, Description, IdScrEng
FROM URepImports
WHERE Id IN (SELECT IdObj FROM URepUsers
                        WHERE (LoginName=user_name() or IS_MEMBER(LoginName)=1) AND IdTypObj=6) OR
              NOT EXISTS (SELECT * FROM URepUsers
                                     WHERE IdTypObj=6 AND IdObj=URepImports.Id) OR
              IS_MEMBER('db_owner')=1 OR IS_MEMBER('URep_Admin')=1


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO


CREATE VIEW vwURepLogins (LoginName, FullName, IsRole) 
AS

select LoginName, FullName, 0
from URepLogins l, sysusers u
where l.LoginName=SUSER_NAME(u.suid)
and u.issqluser=1

union

select name, name, 0  from sysusers su
where issqlrole=0 and hasdbaccess=1
  and not exists(select * from URepLogins ul where ul.LoginName=su.name)

union

select convert(varchar(30), name), ' : '+name+'"',1
from sysusers
where issqlrole=1
and name not like 'db_%'

union

select 'db_owner', '',1






GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO



create view vwURepObjects (Id, IdTypObj, IdObj, ObjName, TypObjName, Numm)
as
  select 1000000+u.Id Id, 1 IdTypObj, u.Id IdObj, GrpName ObjName, l.Item TypObjName, Numm
  from URepGroup u, Lookups l 
  where l.Teg='URepUsers_IdTypObj' and l.Ival=1
  union
  select 2000000+u.Id, 2, u.Id, Name, l.Item, Numm
  from URepForm u, Lookups l 
  where l.Teg='URepUsers_IdTypObj' and l.Ival=2
  union
  select 5000000+u.Id, 5, u.Id, Name, l.Item, Numm
  from URepScript u, Lookups l 
  where l.Teg='URepUsers_IdTypObj' and l.Ival=5
  union
  select 6000000+u.Id, 6, u.Id, Name, l.Item, Numm
  from URepImports u, Lookups l 
  where l.Teg='URepUsers_IdTypObj' and l.Ival=6




GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO



CREATE VIEW dbo.vwURepScript
(Id, Numm, Name, Description, IdScrEng)
AS
SELECT Id, Numm, Name, Description, IdScrEng
FROM URepScript
WHERE Id IN (SELECT IdObj FROM URepUsers
                        WHERE (LoginName = user_name() or IS_MEMBER(LoginName)=1) AND IdTypObj = 5) OR
              NOT EXISTS (SELECT * FROM URepUsers
                                     WHERE IdTypObj = 5 AND IdObj = URepScript.Id) OR
              IS_MEMBER('db_owner')=1 OR IS_MEMBER('URep_Admin')=1








GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE view vwURepRightsByUser (Id, IdTypObj, IdObj, ObjName, TypObjName, Numm, LoginName, IdRight)
as
select Id, IdTypObj, IdObj, ObjName, TypObjName, Numm, LoginName,
 (select Id from URepUsers R
    where R.IdTypObj=O.IdTypObj and
          R.IdObj=O.IdObj and
          R.LoginName=L.LoginName) IdRight      
from vwURepObjects O, vwURepLogins L


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO



CREATE PROCEDURE spURepGetIsAdmin @IsAdmin int OUT
AS
begin
  If /*IS_MEMBER('db_owner')=1 or*/ IS_MEMBER('URep_Admin')=1
    set @IsAdmin = 1
  Else
    set @IsAdmin = 0
end







GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  ON    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepFormDel @IdForm int
AS
begin

  delete URepForm where Id=@IdForm
end





GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepFormNumm @Numm int OUT
AS
begin
 select @Numm = isnull(max(Numm)+10,10) from URepForm
end







GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  ON    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepGrpDel @IdGrp int
AS
begin
  delete URepGroup where Id=@IdGrp
end




GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO



CREATE PROCEDURE spURepGrpNumm @Numm int OUT
AS
begin
  select @Numm=isNull(Max(Numm)+10, 10) from URepGroup
end




GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  ON    SET ANSI_NULLS  ON 
GO



CREATE PROCEDURE spURepImportsNumm AS
begin
 declare @maxID int
 select @maxID = isnull(max(Numm)+10,10) from URepImports
 return @maxID
end




GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  ON    SET ANSI_NULLS  ON 
GO



CREATE PROCEDURE spURepLogAction @IdAction int, @ValueId int, @Name varchar(250)
AS
  insert into URepHistoryLog (IdAction, ValueId, Name, login, username, data)
    values (@IdAction, @ValueId, @Name, SUSER_SNAME(), user, getDate())




GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepQueryNumm @Numm int OUT
AS
begin
 select @Numm = isnull(max(Numm)+10,10) from URepQuery
end





GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE spURepRemoteDataDel @IdRemoteData int
AS
begin
  delete URepParam where IdRemoteData=@IdRemoteData
  delete URepRemoteData where Id=@IdRemoteData
end

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE spURepRemoteDataNumm @Numm int OUT
AS
begin
 select @Numm = isnull(max(Numm)+10,10) from URepRemoteData
end

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO

CREATE PROCEDURE spURepScriptDel @IdScript int
AS
begin
  delete URepScript where Id=@IdScript
end

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO

CREATE PROCEDURE spURepScriptNumm @Numm int OUT
AS
begin
 select @Numm = isnull(max(Numm)+10,10) from URepScript
end

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepFrm2QryNumm @IdForm int, @Numm int OUT
AS
begin
 select @Numm = isnull(max(Numm)+1, 1) 
   from URepFrm2Qry  where IdForm=@IdForm
end








GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepGrpAdd @GrpName varchar(250), @IdGrp int OUT
AS
begin
  declare @Numm int
  Exec spURepGrpNumm @Numm OUT

  begin tran
  insert into URepGroup (GrpName, IdParent, Numm)
    values (@GrpName, NULL, @Numm)
  select @IdGrp = @@IDENTITY
  commit tran
end










GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepParamNumm @IdQuery int, @IdRemoteData int, @Numm int OUT
AS
begin
 if @IdQuery is not NULL and @IdQuery>0
   select @Numm = isnull(max(Numm)+1, 1) 
     from URepParam 
     where IdQuery=@IdQuery
  else
   select @Numm = isnull(max(Numm)+1, 1) 
     from URepParam 
     where IdRemoteData=@IdRemoteData
end






GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepParamsCopy @OldIdQuery int, @OldIdParam int, @NewIdQuery int
AS
begin

declare @Id int, @IdQuery int, @Numm int, @ParName char(40)
CREATE TABLE #TmpParam (
       Id                   int IDENTITY,
       IdQuery              int NOT NULL,
       Numm                 int NOT NULL,
       ParName              char(40) NOT NULL,
       IdParTyp             int NOT NULL,
       ParLabel             char(40) NOT NULL,
       SQL                  text NULL,
       Width                int NULL,
       LookupField          varchar(40) NULL,
       LookupDisplay        varchar(40) NULL,
       LookupDisplayIndex   int NULL,
       IdTypDefVal          int NOT NULL,
       DefSQL               text NULL,
       PRIMARY KEY (Id))

--1. Copy into #TmpParam
if @OldIdQuery>0
  begin
  insert into #TmpParam 
  (IdQuery, Numm, ParName, IdParTyp, ParLabel, SQL, Width, 
   LookupField, LookupDisplay, LookupDisplayIndex, IdTypDefVal, DefSQL)
  select
   @NewIdQuery, Numm, ParName, IdParTyp, ParLabel, SQL, Width, 
   LookupField, LookupDisplay, LookupDisplayIndex, IdTypDefVal, DefSQL
   from URepParam
   where IdQuery=@OldIdQuery
  end
else if @OldIdParam>0
  begin
  insert into #TmpParam 
  (IdQuery, Numm, ParName, IdParTyp, ParLabel, SQL, Width, 
   LookupField, LookupDisplay, LookupDisplayIndex, IdTypDefVal, DefSQL)
  select
   @NewIdQuery, Numm, ParName, IdParTyp, ParLabel, SQL, Width, 
   LookupField, LookupDisplay, LookupDisplayIndex, IdTypDefVal, DefSQL
   from URepParam
   where Id=@OldIdParam
  end

--2. Check and modify #TmpParam and insert into URepParam
DECLARE crsParCopy INSENSITIVE CURSOR FOR  
  select Id, IdQuery, Numm, ParName
      from #TmpParam
OPEN crsParCopy
FETCH crsParCopy INTO @Id, @IdQuery, @Numm, @ParName
         
WHILE @@FETCH_STATUS=0
  BEGIN

  while Exists(select * from URepParam where Numm=@Numm and IdQuery=@IdQuery)
    begin
    select @Numm = @Numm + 1
    end

  while Exists(select * from URepParam where ParName=@ParName and IdQuery=@IdQuery)
    begin
    select @ParName =rtrim(@ParName) + '_'
    end

  insert into URepParam
    (IdQuery, Numm, ParName, IdParTyp, ParLabel, SQL, Width, 
     LookupField, LookupDisplay, LookupDisplayIndex, IdTypDefVal, DefSQL)
  select 
    IdQuery, @Numm, @ParName, IdParTyp, ParLabel, SQL, Width, 
     LookupField, LookupDisplay, LookupDisplayIndex, IdTypDefVal, DefSQL
    from #TmpParam 
    where Id=@Id

  FETCH crsParCopy INTO @Id, @IdQuery, @Numm, @ParName
  END
  CLOSE crsParCopy
  DEALLOCATE crsParCopy
end


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepQueryDel @IdQuery int
AS
begin
  delete URepParam where IdQuery=@IdQuery
  delete URepQuery where Id=@IdQuery
end






GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

CREATE PROCEDURE spURepRemoteDataAdd @Name varchar(250), @IdRemoteData int OUT
AS
begin
  declare @Numm int
  begin tran
  Exec spURepRemoteDataNumm @Numm OUT
  insert into URepRemoteData (Numm, Name, IdRemtServerType)
    values (@Numm, @Name, 1)
  select @IdRemoteData = @@IDENTITY
  commit tran
end

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO

CREATE PROCEDURE spURepScriptAdd @Name varchar(250), @IdScript int OUT
AS
begin
  declare @Numm int
  begin tran
  Exec spURepScriptNumm @Numm OUT
  insert into URepScript (Numm, Name, IdScrEng, ScriptText)
    values (@Numm, @Name, 1, 'MsgBox "Test"')
  select @IdScript = @@IDENTITY
  commit tran
end

GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepFormAdd @Name varchar(250), @IdQuery int, @IdForm int OUT
AS
begin
  declare @Numm int, @IdTypExec int

  if @IdQuery=0
    select @IdTypExec=1 --QR
  else
    select @IdTypExec=1000 --table

  begin tran
  Exec spURepFormNumm @Numm OUT
  insert into URepForm (Numm, Name, IdDestination, IdTypExec)
    values (@Numm, @Name, 0, @IdTypExec)
  select @IdForm = @@IDENTITY

  if @IdQuery<>0
    begin
    Exec spURepFrm2QryNumm @IdForm, @Numm OUT
    insert into URepFrm2Qry (IdForm, Numm, IdQuery, QueryShortName, IsMaster)
      values(@IdForm, @Numm, @IdQuery, 'Query'+Ltrim(Str(@Numm)), 0)
    end
  commit tran

end










GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepParamAdd @parName varchar(40), @IdQuery int, @IdRemoteData int, @IdParam int OUT
AS
begin
  declare @Numm int

  if @IdRemoteData=0 Set @IdRemoteData = NULL
  if @IdQuery=0 Set @IdQuery = NULL

  begin tran
  Exec spURepParamNumm @IdQuery, @IdRemoteData, @Numm OUT 
  insert into URepParam (IdQuery, IdRemoteData, Numm, ParName, ParLabel, IdParTyp, IdTypDefVal)
    values (@IdQuery, @IdRemoteData, @Numm, @parName, @parName, 0, 0)
  select @IdParam = @@IDENTITY
  commit tran

end









GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO



CREATE PROCEDURE spURepQueryAdd @Name varchar(250), @IdForm int, @IdQuery int OUT
AS
begin
  declare @Numm int

  begin tran
  Exec spURepQueryNumm @Numm OUT
  insert into URepQuery (Numm, Name, SQLtext)
    values (@Numm, @Name, 'select * from ')
  select @IdQuery = @@IDENTITY

  if @IdForm<>0
    begin
    Exec spURepFrm2QryNumm @IdForm, @Numm OUT
    insert into URepFrm2Qry (IdForm, Numm, IdQuery, QueryShortName, IsMaster) 
      values (@IdForm, @Numm, @IdQuery, 'Query'+Ltrim(Str(@Numm)), 0)
    end

  commit tran
end












GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

